<?php
namespace PAR\Service;

use PAR\Factory\FindFactory;
use Teknisa\Libs\Util\Environment;
use Teknisa\Libs\Util\NewCode;
use Zeedhi\Framework\DataSource\DataSet;

class FindService {

    protected $findFactory;
    protected $Environment;
    protected $newCode;

    public function __construct (FindFactory $findFactory, Environment $Environment, NewCode $newCode) {
        $this->findFactory  = $findFactory;
        $this->Environment  = $Environment;
        $this->newCode      = $newCode;
    }

    public function findIndiceFinanceiro($filtro) {   
        $where = $this->montarFiltro($filtro);
        return $this->findFactory->findIndiceFinanceiro($where);
    }

    public function montarFiltro($find) {
        $operador = $this->Environment->getCdOperador();
        if(empty($find)){
            return '1 = 1';
        }
        $whereClause = [];
        foreach ($find as $column => $condition) {
            $operator = key($condition);
            $value = $condition[$operator];

            if($value === 'OPERADOR_LOGADO'){
                $value = $operador;
            }

            if (in_array($operator, ["IN", "NOT_IN"])) {
                $value = "($value)";
            } else {
                $value = "'$value'";
            }
        
            $whereClause[] = "$column $operator $value";
        }

        return implode(" AND ", $whereClause);
    }

}
